Index: orxonox/branches/openAL/src/lib/coord/p_node.cc
===================================================================
--- orxonox/branches/openAL/src/lib/coord/p_node.cc	(revision 3921)
+++ orxonox/branches/openAL/src/lib/coord/p_node.cc	(revision 4194)
@@ -60,13 +60,11 @@
   this->init(parent);
 
-  *this->absCoordinate = absCoordinate;
+  this->absCoordinate = absCoordinate;
 
   if (likely(parent != NULL))
   {
-    *this->relCoordinate = *this->absCoordinate - parent->getAbsCoor ();
+    this->relCoordinate = this->absCoordinate - parent->getAbsCoor();
     parent->addChild (this);
   }
-  else 
-    this->relCoordinate = new Vector();
 }
 
@@ -89,10 +87,4 @@
   delete []this->objectName;
 
-  delete this->relCoordinate;
-  delete this->absCoordinate;
-  delete this->relDirection;
-  delete this->absDirection;
-  delete this->lastAbsCoordinate;
-  delete this->diffCoordinate;
 }
 
@@ -107,12 +99,4 @@
   this->parent = parent; 
   this->objectName = NULL;
-  this->time = 1.0; /* set time to 1 to make divisions by zero impossible */
-
-  this->absCoordinate = new Vector();
-  this->relCoordinate = new Vector();
-  this->absDirection = new Quaternion();
-  this->relDirection = new Quaternion();
-  this->lastAbsCoordinate = new Vector();
-  this->diffCoordinate = new Vector();
 }
 
@@ -158,5 +142,5 @@
 {
   this->bRelCoorChanged = true;
-  *this->relCoordinate = relCoord;
+  this->relCoordinate = relCoord;
 }
 
@@ -182,5 +166,5 @@
 {
   this->bAbsCoorChanged = true;
-  *this->absCoordinate = absCoord;
+  this->absCoordinate = absCoord;
 }
 
@@ -211,9 +195,9 @@
   if( unlikely(this->bAbsCoorChanged))
     {
-      *this->absCoordinate = *this->absCoordinate + shift;
+      this->absCoordinate += shift;
     }
   else 
     {
-      *this->relCoordinate = *this->relCoordinate + shift;
+      this->relCoordinate += shift;
       this->bRelCoorChanged = true;
     }
@@ -241,5 +225,5 @@
 {
   this->bRelCoorChanged = true;
-  *this->relDirection = relDir;
+  this->relDirection = relDir;
 }
 
@@ -264,5 +248,5 @@
 {
   this->bAbsDirChanged = true;
-  *this->absDirection = absDir;
+  this->absDirection = absDir;
 }
 
@@ -293,18 +277,6 @@
 {
   this->bRelDirChanged = true;
-  *this->relDirection = *this->relDirection * shift;
-}
-
-
-
-/**
-   \brief this calculates the current movement speed of the node
-*/
-float PNode::getSpeed() const
-{
-  *this->diffCoordinate = *this->absCoordinate - *this->lastAbsCoordinate;
-  return this->diffCoordinate->len() / this->time;
-}
-
+  this->relDirection = this->relDirection * shift;
+}
 
 /**
@@ -432,7 +404,7 @@
 void PNode::update (float dt)
 {
-  *this->lastAbsCoordinate = *this->absCoordinate;
-  this->time = dt;
-  PRINTF(4)("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate->x, this->absCoordinate->y, this->absCoordinate->z);
+  this->lastAbsCoordinate = this->absCoordinate;
+
+  PRINTF(4)("PNode::update - %s - (%f, %f, %f)\n", this->objectName, this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
 
 
@@ -442,5 +414,5 @@
 	{
 	  /* if you have set the absolute coordinates this overrides all other changes */
-	  *this->relCoordinate = *this->absCoordinate - parent->getAbsCoor ();
+	  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
 	}
       if( likely(this->bRelCoorChanged) /*&& this->timeStamp != DataTank::timeStamp*/)
@@ -455,5 +427,5 @@
 	    }
 	    else */
-	  *this->absCoordinate = parent->getAbsCoor() + *this->relCoordinate;	      /* update the current absCoordinate */
+	  this->absCoordinate = parent->getAbsCoor() + this->relCoordinate;	      /* update the current absCoordinate */
 	}
     }
@@ -464,10 +436,10 @@
 	{
 	  /* if you have set the absolute coordinates this overrides all other changes */
-	  *this->relDirection = *this->absDirection - parent->getAbsDir();
+	  this->relDirection = this->absDirection - parent->getAbsDir();
 	}
       else if( likely(this->bRelDirChanged) /*&& this->timeStamp != DataTank::timeStamp*/)
 	{
 	  /* update the current absDirection - remember * means rotation around sth.*/
-	  *this->absDirection = parent->getAbsDir() * *this->relDirection;
+	  this->absDirection = parent->getAbsDir() * this->relDirection;
 	}
     }
@@ -478,5 +450,5 @@
 	{
 	  /* if you have set the absolute coordinates this overrides all other changes */
-	  *this->relCoordinate = *this->absCoordinate - parent->getAbsCoor ();
+	  this->relCoordinate = this->absCoordinate - parent->getAbsCoor ();
 	}
       else if( likely(this->bRelCoorChanged) /*&& this->timeStamp != DataTank::timeStamp*/)
@@ -486,5 +458,5 @@
 	    *this->absCoordinate = *this->relCoordinate;
 	    else*/
-	  *this->absCoordinate = parent->getAbsCoor() + parent->getAbsDir().apply(*this->relCoordinate);	      /* update the current absCoordinate */
+	  this->absCoordinate = parent->getAbsCoor() + parent->getAbsDir().apply(this->relCoordinate);	      /* update the current absCoordinate */
 	}
     }
@@ -508,4 +480,5 @@
   delete iterator;
 
+  this->velocity = (this->absCoordinate - this->lastAbsCoordinate) / dt;
   this->timeStamp = timeStamp;
   this->bRelCoorChanged = false;
@@ -540,7 +513,7 @@
 {
   PRINTF(2)("PNode::debug() - absCoord: (%f, %f, %f)\n", 
-	 this->absCoordinate->x, 
-	 this->absCoordinate->y,
-	 this->absCoordinate->z);
+	 this->absCoordinate.x, 
+	 this->absCoordinate.y,
+	 this->absCoordinate.z);
 }
 
@@ -551,5 +524,5 @@
   for debug purposes realy usefull, not used to work properly
 */
-void PNode::setName (char* newName)
+void PNode::setName (const char* newName)
 {
   this->objectName = new char[strlen(newName)+1];
@@ -561,5 +534,5 @@
   \brief gets the name of the node
 */
-char* PNode::getName ()
+const char* PNode::getName ()
 {
   return this->objectName;
Index: orxonox/branches/openAL/src/lib/coord/p_node.h
===================================================================
--- orxonox/branches/openAL/src/lib/coord/p_node.h	(revision 3921)
+++ orxonox/branches/openAL/src/lib/coord/p_node.h	(revision 4194)
@@ -57,17 +57,20 @@
 
 
-  inline Vector* getRelCoor () const { return this->relCoordinate; }
+  inline const Vector& getRelCoor () const { return this->relCoordinate; }
   void setRelCoor (const Vector& relCoord);
-  inline Vector getAbsCoor () const { return *this->absCoordinate; }
+  inline const Vector& getAbsCoor () const { return this->absCoordinate; }
   void setAbsCoor (const Vector& absCoord);
   void shiftCoor (const Vector& shift);
 
-  inline Quaternion getRelDir () const { return *this->relDirection; }
+  inline const Quaternion& getRelDir () const { return this->relDirection; }
   void setRelDir (const Quaternion& relDir);
-  inline Quaternion getAbsDir () const { return *this->absDirection; }
+  inline const Quaternion& getAbsDir () const { return this->absDirection; }
   void setAbsDir (const Quaternion& absDir);
   void shiftDir (const Quaternion& shift);
 
-  float getSpeed() const;
+  /** \returns the Speed of the Node */
+  inline float getSpeed() const {return this->velocity.len()/1000;} //! \FIX THIS SHOULD NOT BE /1000
+  /** \returns the Velocity of the Node */
+  inline const Vector& getVelocity() const {return this->velocity;}
 
   void addChild (PNode* pNode, int parentingMode = DEFAULT_MODE);
@@ -85,6 +88,6 @@
   void processTick (float dt);
 
-  void setName (char* newName);
-  char* getName ();
+  void setName (const char* newName);
+  const char* getName ();
 
 
@@ -99,8 +102,8 @@
   bool bRelDirChanged;     //!< If Relative Direction has changed since last time we checked
 
-  Vector* relCoordinate;    //!< coordinates relative to the parent
-  Vector* absCoordinate;    //!< absolute coordinates in the world ( from (0,0,0) )
-  Quaternion* relDirection; //!< direction relative to the parent
-  Quaternion* absDirection; //!< absolute direvtion in the world ( from (0,0,1) )
+  Vector relCoordinate;    //!< coordinates relative to the parent
+  Vector absCoordinate;    //!< absolute coordinates in the world ( from (0,0,0) )
+  Quaternion relDirection; //!< direction relative to the parent
+  Quaternion absDirection; //!< absolute direvtion in the world ( from (0,0,1) )
 
   int mode;                //!< the mode of the binding
@@ -109,7 +112,6 @@
   void init(PNode* parent);
 
-  Vector* lastAbsCoordinate; //!< this is used for speedcalculation, it stores the last coordinate
-  Vector* diffCoordinate;    //!< this is stored here for performance reasons, difference to the last vector
-  float time;                //!< time since last update
+  Vector velocity;          //!< Saves the velocity.
+  Vector lastAbsCoordinate; //!< this is used for speedcalculation, it stores the last coordinate
 };
 
Index: orxonox/branches/openAL/src/lib/graphics/graphics_engine.cc
===================================================================
--- orxonox/branches/openAL/src/lib/graphics/graphics_engine.cc	(revision 3921)
+++ orxonox/branches/openAL/src/lib/graphics/graphics_engine.cc	(revision 4194)
@@ -17,4 +17,5 @@
 
 #include "graphics_engine.h"
+#include "resource_manager.h"
 
 #include "debug.h"
@@ -30,4 +31,7 @@
 {
   this->setClassName ("GraphicsEngine");
+
+  this->fullscreen = false;
+
   this->initVideo();
 
@@ -101,6 +105,8 @@
   
   // TO DO: Create a cool icon and use it here
-  SDL_WM_SetIcon(SDL_LoadBMP("../data/pictures/orxonox-icon32x32.bmp"), NULL);  
-
+  char* loadPic = new char[strlen(ResourceManager::getInstance()->getDataDir())+ 100];
+  sprintf(loadPic, "%s%s", ResourceManager::getInstance()->getDataDir(),  "pictures/orxonox-icon32x32.bmp");
+  SDL_WM_SetIcon(SDL_LoadBMP(loadPic), NULL);  
+  delete loadPic;
   // Enable default GL stuff
   glEnable(GL_DEPTH_TEST);
@@ -137,10 +143,15 @@
 int GraphicsEngine::setResolution(int width, int height, int bpp)
 {
+  Uint32 fullscreenFlag;
   this->resolutionX = width;
   this->resolutionY = height;
   this->bitsPerPixel = bpp;
+  if (this->fullscreen)
+    fullscreenFlag = SDL_FULLSCREEN;
+  else
+    fullscreenFlag = 0;
   
   printf ("ok\n");
-  if((this->screen = SDL_SetVideoMode(this->resolutionX, this->resolutionY, this->bitsPerPixel, this->videoFlags)) == NULL)
+  if((this->screen = SDL_SetVideoMode(this->resolutionX, this->resolutionY, this->bitsPerPixel, this->videoFlags | fullscreenFlag)) == NULL)
     {
       PRINTF(1)("Could not SDL_SetVideoMode(%d, %d, %d, %d): %s\n", this->resolutionX, this->resolutionY, this->bitsPerPixel, this->videoFlags, SDL_GetError());
@@ -148,5 +159,10 @@
       //    return -1;
     }
-
+}
+
+void GraphicsEngine::setFullscreen(bool fullscreen)
+{
+  this->fullscreen = fullscreen;
+  this->setResolution(this->resolutionX, this->resolutionY, this->bitsPerPixel);
 }
 
@@ -254,5 +270,5 @@
   /* Check if our resolution is restricted */
   if(this->videoModes == (SDL_Rect **)-1){
-    PRINTF(1)("All resolutions available.\n");
+    PRINTF(2)("All resolutions available.\n");
   }
   else{
@@ -260,5 +276,5 @@
     PRINT(0)("Available Resoulution Modes are\n");
     for(int i = 0; this->videoModes[i]; ++i)
-      PRINT(0)(" |  %d x %d\n", this->videoModes[i]->w, this->videoModes[i]->h);
+      PRINT(4)(" |  %d x %d\n", this->videoModes[i]->w, this->videoModes[i]->h);
   }
   
Index: orxonox/branches/openAL/src/lib/graphics/graphics_engine.h
===================================================================
--- orxonox/branches/openAL/src/lib/graphics/graphics_engine.h	(revision 3921)
+++ orxonox/branches/openAL/src/lib/graphics/graphics_engine.h	(revision 4194)
@@ -26,4 +26,5 @@
   int setGLattribs(void);
   int setResolution(int width, int height, int bpp);
+  void setFullscreen(bool fullscreen = false);
   /** \returns the x resolution */
   inline int getResolutionX(void) {return this->resolutionX;}
Index: orxonox/branches/openAL/src/lib/graphics/importer/array.cc
===================================================================
--- orxonox/branches/openAL/src/lib/graphics/importer/array.cc	(revision 3921)
+++ orxonox/branches/openAL/src/lib/graphics/importer/array.cc	(revision 4194)
@@ -112,24 +112,7 @@
   
 /**
-   \brief Gives back the array !! MUST be executed AFTER finalize.
-   \returns The created array.
-*/
-GLfloat* Array::getArray ()
-{
-  return this->array;
-}
-
-/**
-   \returns The Count of entries in the Array
-*/
-int Array::getCount()
-{
-  return this->entryCount;
-}
-
-/**
    \brief Simple debug info about the Array
 */
-void Array::debug ()
+void Array::debug (void) const
 {
   PRINT(0)("entryCount=%i, address=%p\n", this->entryCount, this->array);
Index: orxonox/branches/openAL/src/lib/graphics/importer/array.h
===================================================================
--- orxonox/branches/openAL/src/lib/graphics/importer/array.h	(revision 3921)
+++ orxonox/branches/openAL/src/lib/graphics/importer/array.h	(revision 4194)
@@ -23,7 +23,9 @@
   void addEntry(GLfloat entry0, GLfloat entry1, GLfloat entry2);
   
-  GLfloat* getArray ();
-  int getCount();
-  void debug(void);
+  /** \returns The array */
+  inline const GLfloat* getArray () const {return this->array;}
+  /**   \returns The Count of entries in the Array*/
+  inline int getCount(void)const {return this->entryCount;}
+  void debug(void) const ;
  private:
   //! One entry of the Array
Index: orxonox/branches/openAL/src/lib/graphics/importer/framework.cc
===================================================================
--- orxonox/branches/openAL/src/lib/graphics/importer/framework.cc	(revision 3921)
+++ orxonox/branches/openAL/src/lib/graphics/importer/framework.cc	(revision 4194)
@@ -79,5 +79,5 @@
     obj = new OBJModel(argv[1]);
   else 
-    obj = new PrimitiveModel(SPHERE);
+    obj = new PrimitiveModel(CYLINDER);
 
   M = Vector(wHandler.screen->w/2, wHandler.screen->h/2, 0); 
Index: orxonox/branches/openAL/src/lib/graphics/importer/material.cc
===================================================================
--- orxonox/branches/openAL/src/lib/graphics/importer/material.cc	(revision 3921)
+++ orxonox/branches/openAL/src/lib/graphics/importer/material.cc	(revision 4194)
@@ -45,12 +45,7 @@
   this->setTransparency(1.0);
 
-
   this->diffuseTexture = NULL;
   this->ambientTexture = NULL;
   this->specularTexture = NULL;
-
-  this->diffuseTextureSet = false;
-  this->ambientTextureSet = false;
-  this->specularTextureSet = false;
 
   this->setName(mtlName);
@@ -88,9 +83,5 @@
   
   // setting the transparency
-  if (this->transparency == 1.0)
-    {
-      glDisable(GL_BLEND);
-    }
-  else
+  if (this->transparency < 1.0)
     {
       glEnable(GL_BLEND);
@@ -98,4 +89,10 @@
       glBlendFunc(GL_SRC_ALPHA, GL_ONE);
     }
+  else
+    {
+      glDisable(GL_BLEND);
+      glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+    }
+
 
   // setting illumination Model 
@@ -105,8 +102,15 @@
     glShadeModel(GL_SMOOTH);
 
-  if (this->diffuseTextureSet)
+  if (this->diffuseTexture)
     {
       glEnable(GL_TEXTURE_2D);
       glBindTexture(GL_TEXTURE_2D, this->diffuseTexture->getTexture());
+
+      /* This allows alpha blending of 2D textures with the scene */
+      if (this->diffuseTexture->hasAlpha())
+	{
+	  glEnable(GL_BLEND);
+	  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+	}
     }
   else
@@ -291,10 +295,8 @@
 {
   PRINTF(4)("setting Diffuse Map %s\n", dMap);
-  //    diffuseTexture = new Texture();
-  //    this->diffuseTextureSet = diffuseTexture->loadImage(dMap);
 
   //! \todo check if RESOURCE MANAGER is availiable
   //! \todo Textures from .mtl-file need special care.
-  this->diffuseTextureSet = this->diffuseTexture = (Texture*)ResourceManager::getInstance()->load(dMap, IMAGE);
+  this->diffuseTexture = (Texture*)ResourceManager::getInstance()->load(dMap, IMAGE);
 }
 
Index: orxonox/branches/openAL/src/lib/graphics/importer/material.h
===================================================================
--- orxonox/branches/openAL/src/lib/graphics/importer/material.h	(revision 3921)
+++ orxonox/branches/openAL/src/lib/graphics/importer/material.h	(revision 4194)
@@ -67,9 +67,4 @@
   Texture* ambientTexture; //!< The ambient texture of the Material.
   Texture* specularTexture;//!< The specular texture of the Material.
-  
-  bool diffuseTextureSet; //!< Chekcs if the diffuse texture is Set.
-  bool ambientTextureSet; //!< Chekcs if the ambient texture is Set.
-  bool specularTextureSet;//!< Chekcs if the specular texture is Set.
-
 };
 #endif
